version: "3.3"
services:
  api:
    image: registry.mesocentre.uca.fr/mesocentre/openlink-api:latest
    container_name: openlink-api01
    env_file: .env
    entrypoint: bash ./docker-entrypoint.sh
    ports:
      - "8000:8000"
    depends_on:
      - db
      - vault
      - vault-configurator
  client:
    image: registry.mesocentre.uca.fr/mesocentre/openlink-client:latest
    container_name: openlink-client01
    env_file: .env
    command: sh ./docker-entrypoint.sh
    ports:
      - "3000:3000"
  db:
    image: postgres:12-alpine
    volumes:
      - postgres-data:/var/postgresql/data/
    environment:
      - POSTGRES_DB=openlinkdb
      - POSTGRES_USER=postgres
      - POSTGRES_PASSWORD=postgres
  vault:
    image: vault:1.13.3
    environment:
      VAULT_ADDR: "http://0.0.0.0:8200"
      VAULT_API_ADDR: "http://0.0.0.0:8200"
      VAULT_ADDRESS: "http://0.0.0.0:8200"
      VAULT_UI: "true"
    ports:
      - "8200:8200"
    restart: always
    volumes:
      - ./vault/logs:/vault/logs
      - ./vault/data:/vault/data
      - ./vault/config:/vault/config
    cap_add:
      - IPC_LOCK
    entrypoint: vault server -config /vault/config/config.hcl
  vault-configurator:
    build: ./vault_configurator
    entrypoint: bash ./vault_config.sh
    depends_on:
      - vault
volumes:
  postgres-data:
